// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AnimationEffect.pas' rev: 3.00

#ifndef AnimationEffectHPP
#define AnimationEffectHPP
#include <EffectUtils.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Animationeffect
{
//-- type declarations -------------------------------------------------------
struct TMathPoint
{
	float X;
	float Y;
} ;

struct TMatrix
{
	float M11;
	float M12;
	float M13;
	float M21;
	float M22;
	float M23;
	float M31;
	float M32;
	float M33;
} ;

struct TSpikeData
{
	TMathPoint TriangleEnd[3][16];
	TMathPoint EndCenter[16];
	TMathPoint TriangleCenter[16];
	TMatrix MatrixCircle[16];
} ;

enum TAnimationType { atInit, atDraw, atErase };

enum TAnimationEffectType { etRandom, etSpin, etVortex, etScatterGather, etSpike, etFireworks };

class DELPHICLASS TAnimationEffect;
class PASCALIMPLEMENTATION TAnimationEffect : public Effectutils::TFormAnimationEffect 
{
	typedef Effectutils::TFormAnimationEffect inherited;
	
private:
	Word FDelay;
	Byte FFrames;
	Byte FFireworkBlasts;
	TAnimationEffectType FEffectType;
	Byte FSteps;
	HDC DrawDC;
	float EffectParam;
	TMatrix GlobalMatrix;
	TMathPoint FireworksData[256];
	int AfterImages;
	int TotalSteps;
	int Step;
	TMathPoint RightTop;
	TMathPoint Center;
	TSpikeData SpikeData;
	TAnimationEffectType CurrentEffect;
	void __fastcall Animate(bool Open);
	void __fastcall AnimationSelect(TAnimationType AnimationType);
	void __fastcall efSpinFrame(TAnimationType AnimationType);
	void __fastcall efVortexFrames(TAnimationType AnimationType);
	void __fastcall efScatterGatherFrames(TAnimationType AnimationType);
	void __fastcall efSpikeFrames(TAnimationType AnimationType);
	void __fastcall efFireworxFrames(TAnimationType AnimationType);
	
protected:
	virtual void __fastcall DoAnimateOnShow(void);
	virtual void __fastcall DoAnimateOnHide(void);
	
public:
	__fastcall virtual TAnimationEffect(Classes::TComponent* aOwner);
	void __fastcall Open(void);
	void __fastcall Close(void);
	
__published:
	__property AnimateOnShow ;
	__property AnimateOnHide ;
	__property Word Delay = {read=FDelay, write=FDelay, default=100};
	__property Byte FireworkBlasts = {read=FFireworkBlasts, write=FFireworkBlasts, default=10};
	__property Byte Frames = {read=FFrames, write=FFrames, default=6};
	__property TAnimationEffectType EffectType = {read=FEffectType, write=FEffectType, default=0};
	__property Byte Steps = {read=FSteps, write=FSteps, default=50};
public:
	/* TFormAnimationEffect.Destroy */ __fastcall virtual ~TAnimationEffect(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
#define DEF_AE_DELAY (Byte)(100)
#define DEF_AE_FIREWORKBLASTS (Byte)(10)
#define DEF_AE_FRAMES (Byte)(6)
#define DEF_AE_STEPS (Byte)(50)

}	/* namespace Animationeffect */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Animationeffect;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// AnimationEffect
